<template>
  <div>
    <base-dialog
      :show="!!error"
      title="An error occurred!"
      @close="handleError"
    >
      <p>{{ error }}</p>
    </base-dialog>
    <div class="container grid invoices">
      <invoice-header
        :total="invoices.length"
        class="invoices-header"
        @new-invoice="newInvoice"
        @change-filter="filteredInvoices"
      ></invoice-header>
      <TransitionGroup name="list">
        <invoice-item
          v-for="invoice in invoices"
          :key="invoice.id"
          :invoice="invoice"
        ></invoice-item>
      </TransitionGroup>
      <h3 v-if="!hasInvoices">No invoices found.</h3>
    </div>
    <transition name="scale-slide">
      <invoice-form
        v-if="showNewInoviceForm"
        @discard="discard"
        @save-invoice="saveInvoice"
        class="new-invoice-form"
      ></invoice-form>
    </transition>
  </div>
</template>

<script>
import InvoiceItem from "@/components/invoices/InvoiceItem.vue";
import InvoiceHeader from "@/components/invoices/InvoiceHeader.vue";
import InvoiceForm from "@/components/invoices/InvoiceForm.vue";

export default {
  components: {
    InvoiceItem,
    InvoiceHeader,
    InvoiceForm,
  },
  title() {
    return this.title;
  },
  watch: {
    invoices() {
      document.title = `Invoices (${this.invoices?.length}) | Frontend Mentor`;
    },
  },
  data() {
    return {
      showNewInoviceForm: false,
      isLoading: false,
      error: null,
    };
  },

  computed: {
    invoices() {
      return this.$store.getters["invoices/invoices"];
    },
    hasInvoices() {
      return !this.isLoading && this.$store.getters["invoices/hasInvoices"];
    },
    title() {
      return `Invoices (${this.invoices?.length}) | Frontend Mentor`;
    },
  },
  created() {
    this.loadInvoices();
  },
  methods: {
    async loadInvoices(filters = null) {
      this.isLoading = true;
      try {
        await this.$store.dispatch("invoices/loadInvoices", {
          filters: filters,
        });
      } catch (error) {
        this.error = error.message || "Something went wrong!";
      }
      this.isLoading = false;
    },
    async filteredInvoices(data) {
      this.loadInvoices(data);
    },
    newInvoice() {
      this.showNewInoviceForm = true;
    },
    discard() {
      this.showNewInoviceForm = false;
    },
    async saveInvoice(data) {
      this.discard();
      this.isLoading = true;
      try {
        await this.$store.dispatch("invoices/createInvoice", data);
      } catch (error) {
        this.error = error.message || "Something went wrong!";
      }
      this.isLoading = false;
    },
    handleError() {
      this.error = null;
    },
  },
};
</script>

<style scoped>
.new-invoice-form {
  position: fixed;
  top: 5rem;
  left: 0px;
  z-index: 10;
  background: hsl(var(--clr-form-bg));
}

.invoices-header {
  margin-bottom: 3rem;
}
@media (min-width: 56.25em) {
  .new-invoice-form {
    top: 0;
    left: 6rem;
  }
  .container {
    max-width: 50rem;
  }
}
.list-enter-active,
.list-leave-active {
  transition: all 0.5s ease;
}
.list-enter-from,
.list-leave-to {
  opacity: 0;
  transform: translateX(30px);
}
.scale-slide-enter-active,
.scale-slide-leave-active {
  transition: all 0.85s ease;
}
.scale-slide-leave-to,
.scale-slide-enter-from {
  left: -100%;
}
@media (min-width: 56.25em) {
  .scale-slide-leave-from,
  .scale-slide-enter-to {
    left: 6rem;
  }
}
</style>
